Multiscroll.Tool.Pan = function(parent) {
	this.gutter = 5;
	this.paddingNW = 5;
	this.paddingSE = 20;
	this.parent = parent;	// to monitor clientX, clientY
	this.scaleFactor = 0;
	this.columns = 1;
	this.rows = 1;
	this.screen = 0;
	this.oldScaleFactor = 1;
	this.docOldLocation = null;
	this.markerNode = {
		document : null,
		background : null,
		thumbnail : null,
		window : null
	};
	this.docMarkerLeft = this.docMarkerTop = this.docMarkerWidth = this.docMarkerHeight = 0,
	this.winMarkerWidth = this.winMarkerHeight = 0;
	this.winMarkerLeft getter= function() { with (this) {
		if (columns == 1 && rows == 1) {
			return Math.min(docMarkerLeft + docMarkerWidth - winMarkerWidth, 
					Math.max(docMarkerLeft,
						parent.event.clientX - winMarkerWidth / 2));
		} else if (columns > 1) {
			return Math.min(docMarkerLeft + (docMarkerWidth + gutter) * screen + docMarkerWidth - winMarkerWidth,
					Math.max(docMarkerLeft + (docMarkerWidth + gutter) * screen,
						parent.event.clientX - winMarkerWidth / 2));
		} else if (rows > 1) {
			return Math.min(docMarkerLeft + docMarkerWidth - (screen == rows - 1 ? winMarkerWidth : winMarkerWidth / 2), 
					Math.max(docMarkerLeft - (screen == 0 ? 0 : winMarkerWidth / 2),
						parent.event.clientX - winMarkerWidth / 2));
		}
	} };
	this.winMarkerTop getter= function() { with (this) {
		if (columns == 1 && rows == 1) {
			return Math.min(docMarkerTop + docMarkerHeight - winMarkerHeight, 
					Math.max(docMarkerTop,
						parent.event.clientY - winMarkerHeight / 2));
		} else if (columns > 1) {
			return Math.min(docMarkerTop + docMarkerHeight - (screen == columns - 1 ? winMarkerHeight : winMarkerHeight / 2), 
					Math.max(docMarkerTop - (screen == 0 ? 0 : winMarkerHeight / 2),
						parent.event.clientY - winMarkerHeight / 2));
		} else if (rows > 1) {
			return Math.min(docMarkerTop + (docMarkerHeight + gutter) * screen + docMarkerHeight - winMarkerHeight,
					Math.max(docMarkerTop + (docMarkerHeight + gutter) * screen,
						parent.event.clientY - winMarkerHeight / 2));
		}
	} };
};

Multiscroll.Tool.Pan.wireframe = 0;
Multiscroll.Tool.Pan.textured = 1;
Multiscroll.Tool.Pan.thumbnail = 2;

Multiscroll.Tool.Pan.prototype = new Multiscroll.Tool({
	start : function(evt) {
		this.active = true;
		this.done = true;
		
		if (this.settings.marker)
			this.insertMarker(evt);
		window.setCursor(this.cursor);
	},
	stop : function(evt) {
		this.active = false;
		this.removeMarker(evt);
		window.setCursor("default");
	},
	execute : function(evt) { with (this) {
		window.setCursor(cursor);
		
		markerNode.window.style.left = winMarkerLeft + "px";
		markerNode.window.style.top = winMarkerTop + "px";
		
		if (columns == 1 && rows == 1) {
			screen = 0;
		} else if (columns > 1) {
			screen = Math.floor((parent.event.clientX - docMarkerLeft + gutter / 2) / (docMarkerWidth + gutter));
			if (screen < 0) screen = 0; if (screen >= columns) screen = columns - 1;
		} else if (rows > 1) {
			screen = Math.floor((parent.event.clientY - docMarkerTop + gutter / 2) / (docMarkerHeight + gutter));
			if (screen < 0) screen = 0; if (screen >= rows) screen = rows - 1;
		}

		if (settings.appearance == Multiscroll.Tool.Pan.textured) {
			var pageMarkerLeft = docMarkerLeft;
			var pageMarkerTop = docMarkerTop;
			if (columns > 1) pageMarkerLeft += (docMarkerWidth + gutter) * screen;
			if (rows > 1) pageMarkerTop += (docMarkerHeight + gutter) * screen;
			for (var i = 0; i < 8; i++) {
				var el = markerNode.background[i];
				el.style.left = 1 + ((i+2)%8<3 ? pageMarkerLeft : winMarkerLeft + ((i+6)%8<3 ? winMarkerWidth : 0)) + "px";
				el.style.top = (i%8<3 ? pageMarkerTop : winMarkerTop + ((i+4)%8<3 ? winMarkerHeight : 0)) + "px";
				el.style.width = ((i+2)%8<3 ? winMarkerLeft - pageMarkerLeft : ((i+6)%8<3 ? pageMarkerLeft + docMarkerWidth - winMarkerLeft - winMarkerWidth : winMarkerWidth)) + "px";
				el.style.height = (i%8<3 ? winMarkerTop - pageMarkerTop : ((i+4)%8<3 ? pageMarkerTop + docMarkerHeight - winMarkerTop - winMarkerHeight : winMarkerHeight)) + "px";
			}
		}
		if (columns == 1 && rows == 1) {
			scrollX = (winMarkerLeft - docMarkerLeft) / scaleFactor;
			scrollY = (winMarkerTop - docMarkerTop) / scaleFactor;
		} else if (columns > 1) {
			scrollX = (winMarkerLeft - docMarkerLeft - (docMarkerWidth + gutter) * screen) / scaleFactor;
			scrollY = (winMarkerTop - docMarkerTop + docMarkerHeight * screen) / scaleFactor;
		} else if (rows > 1) {
			scrollX = (winMarkerLeft - docMarkerLeft + docMarkerWidth * screen) / scaleFactor;
			scrollY = (winMarkerTop - docMarkerTop - (docMarkerHeight + gutter) * screen) / scaleFactor;
		}
		client.frame.scrollTo(scrollX, scrollY);
	} },
	insertMarker : function(evt) { with (this) {
		var docBox = client.document.getBoxObjectFor(client.document.documentElement);
		var el;

		clientX = evt.clientX;
		clientY = evt.clientY;
		var pageXOffset = client.frame.pageXOffset;
		var pageYOffset = client.frame.pageYOffset;
		var documentWidth = docBox.width;
		var documentHeight = docBox.height;
		windowWidth = Math.min(client.frame.innerWidth, documentWidth); // why are scrollbars included
		windowHeight = Math.min(client.frame.innerHeight, documentHeight); // in window.innerWidth?
		
		this.calculateGrid(clientX, clientY, windowWidth, windowHeight, documentWidth, documentHeight, pageXOffset, pageYOffset);
		
		docMarkerWidth = documentWidth * scaleFactor / rows;
		docMarkerHeight = documentHeight * scaleFactor / columns;
		winMarkerWidth = windowWidth * scaleFactor;
		winMarkerHeight = windowHeight * scaleFactor;

		docMarkerLeft = clientX - winMarkerWidth / 2 - pageXOffset * scaleFactor;
		docMarkerTop = clientY - winMarkerHeight / 2 - pageYOffset * scaleFactor;
	
		// document boxen
		if (settings.appearance == Multiscroll.Tool.Pan.thumbnail && (Math.abs(Math.log(oldScaleFactor/scaleFactor)) > 0.1
				 || docOldLocation != client.document.location.href)) {
			el = client.document.createElementNS("http://www.w3.org/1999/xhtml", "div");
			el.style.overflow = "hidden";
			cloneElementToThumbnail(client.body, el, scaleFactor);

			markerNode.thumbnail = el;
			oldScaleFactor = scaleFactor;
			docOldLocation = client.document.location.href;
		}
		markerNode.document = [];
		for (var i = 0; i < columns; i++) {
			markerNode.document[i] = [];
			for (var j = 0; j < rows; j++) {
				if (settings.appearance == Multiscroll.Tool.Pan.wireframe) {
					el = client.document.createElementNS("http://www.w3.org/1999/xhtml", "div");
				} else if (settings.appearance == Multiscroll.Tool.Pan.textured) {
					el = client.document.createElementNS("http://www.w3.org/1999/xhtml", "div");
					el.style.backgroundImage = "url('" + image.docCorner + "')";
					el.style.backgroundPosition = "top right";
					el.style.backgroundRepeat = "no-repeat";
				} else if (settings.appearance == Multiscroll.Tool.Pan.thumbnail) {
					el = client.document.createElementNS("http://www.w3.org/1999/xhtml", "div");
					var el2 = markerNode.thumbnail.cloneNode(true);
					el2.style.position = "relative";
					el2.style.left = -docMarkerWidth * j + "px";
					el2.style.top = -docMarkerHeight * i + "px";
					el.style.overflow = "hidden";
					el.appendChild(el2);
				}
				el.style.position = "fixed";
				el.style.left = docMarkerLeft + (docMarkerWidth + gutter) * i + "px";
				el.style.top = docMarkerTop + (docMarkerHeight + gutter) * j + "px";
				el.style.width = docMarkerWidth + "px";
				el.style.height = docMarkerHeight + "px";
				el.style.cursor = cursor;
				el.style.border = "2px solid gray";
				
				client.body.appendChild(el);
				
				markerNode.document[i][j] = el;
			}
		}
	
		// window box
		if (settings.appearance == Multiscroll.Tool.Pan.textured) {
			el = client.document.createElementNS("http://www.w3.org/1999/xhtml", "img");
			el.src = image.screen;
		} else {
			el = client.document.createElementNS("http://www.w3.org/1999/xhtml", "div");
		}
		el.style.position = "fixed";
		el.style.left = winMarkerLeft + "px";
		el.style.top = winMarkerTop + "px";
		el.style.width = winMarkerWidth + "px";
		el.style.height = winMarkerHeight + "px";
		el.style.cursor = cursor;
		el.style.border = "1px solid black";
	
		client.body.appendChild(el);
	
		markerNode.window = el;
	
		if (settings.appearance == Multiscroll.Tool.Pan.textured) {
			var pageMarkerLeft = docMarkerLeft;
			var pageMarkerTop = docMarkerTop;
			if (columns > 1) pageMarkerLeft += (docMarkerWidth + gutter) * screen;
			if (rows > 1) pageMarkerTop += (docMarkerHeight + gutter) * screen;
			markerNode.background = [];
			for (var i = 0; i < 8; i++) {
				el = client.document.createElementNS("http://www.w3.org/1999/xhtml", "div");
				el.style.position = "fixed";
				el.style.left = 1 + ((i+2)%8<3 ? pageMarkerLeft : winMarkerLeft + ((i+6)%8<3 ? winMarkerWidth : 0)) + "px";
				el.style.top = (i%8<3 ? pageMarkerTop : winMarkerTop + ((i+4)%8<3 ? winMarkerHeight : 0)) + "px";
				el.style.width = ((i+2)%8<3 ? winMarkerLeft - pageMarkerLeft : ((i+6)%8<3 ? pageMarkerLeft + docMarkerWidth - winMarkerLeft - winMarkerWidth : winMarkerWidth)) + "px";
				el.style.height = (i%8<3 ? winMarkerTop - pageMarkerTop : ((i+4)%8<3 ? pageMarkerTop + docMarkerHeight - winMarkerTop - winMarkerHeight : winMarkerHeight)) + "px";
				el.style.cursor = cursor;
				el.style.backgroundImage = "url('" + image.docBody + "')";
				client.body.appendChild(el);
				markerNode.background[i] = el;
			}
		}
	} },
	removeMarker : function() { with (this) {
		if (markerNode.document != null)
			for (var i = 0; i < columns; i++) {
				for (var j = 0; j < rows; j++) {
					markerNode.document[i][j].parentNode.removeChild(markerNode.document[i][j]);
					markerNode.document[i][j] = null;
				}
				markerNode.document[i] = null;
			}
	
		if (markerNode.window != null)
			markerNode.window.parentNode.removeChild(markerNode.window);
	
		if (settings.appearance == Multiscroll.Tool.Pan.textured)
			for (var i = 0; i < 8; i++)
				if (markerNode.background[i] != null) {
					markerNode.background[i].parentNode.removeChild(markerNode.background[i]);
					markerNode.background[i] = null;
				}
			
		markerNode.document = null;
		markerNode.window = null;
	
		if (settings.appearance == Multiscroll.Tool.Pan.textured)
			markerNode.background = null;
	} },
});
mergeObjects(Multiscroll.Tool.Pan.prototype, {
	calculateGrid : function(clientX, clientY, windowWidth, windowHeight, documentWidth, documentHeight, pageXOffset, pageYOffset) { with (this) {
		var aspectRatio = documentHeight / documentWidth;
		if (!settings.paged) aspectRatio = 1;
		columns = rows = 1;
		if (aspectRatio > 1) {
			scaleFactor = 0;
			var best = { columns : 0, scaleFactor : 0, screen : 0 };
			for (columns = 1; columns < aspectRatio; columns++) {
				calculateScaleFactor(columns, rows, clientX, clientY, windowWidth, windowHeight, documentWidth, documentHeight, pageXOffset, pageYOffset);
				if (scaleFactor > best.scaleFactor) {
					best.columns = columns;
					best.scaleFactor = scaleFactor;
					best.screen = screen;
				}
			}
			columns = best.columns;
			scaleFactor = best.scaleFactor;
			screen = best.screen;
		} else if (aspectRatio < 1) {
			scaleFactor = 0;
			var best = { rows : 0, scaleFactor : 0, screen : 0 };
			for (rows = 1; rows < 1 / aspectRatio; rows++) {
				calculateScaleFactor(columns, rows, clientX, clientY, windowWidth, windowHeight, documentWidth, documentHeight, pageXOffset, pageYOffset);
				if (scaleFactor > best.scaleFactor) {
					best.rows = rows;
					best.scaleFactor = scaleFactor;
					best.screen = screen;
				}
			}
			rows = best.rows;
			scaleFactor = best.scaleFactor;
			screen = best.screen;
		} else {
			calculateScaleFactor(columns, rows, clientX, clientY, windowWidth, windowHeight, documentWidth, documentHeight, pageXOffset, pageYOffset);
		}
	} },
	calculateScaleFactor : function(columns, rows, clientX, clientY, windowWidth, windowHeight, documentWidth, documentHeight, pageXOffset, pageYOffset) { with (this) {
		// magic formula - do the maths if you don't trust it!
		scaleFactor = 1;
		if (columns == 1 && rows == 1) {
			screen = 0;
			scaleFactor = Math.min(scaleFactor, 
				(clientX - paddingNW) / (windowWidth / 2 + pageXOffset));
			scaleFactor = Math.min(scaleFactor, 
				(windowWidth - paddingSE - clientX) / (documentWidth - windowWidth / 2 - pageXOffset));
			scaleFactor = Math.min(scaleFactor, 
				(clientY - paddingNW) / (windowHeight / 2 + pageYOffset));
			scaleFactor = Math.min(scaleFactor, 
				(windowHeight - paddingSE - clientY) / (documentHeight - windowHeight / 2 - pageYOffset));
		} else if (columns > 1) {
			screen = Math.floor(columns * pageYOffset / documentHeight);
			scaleFactor = Math.min(scaleFactor,
				(clientX - screen * gutter - paddingNW) / (windowWidth * (screen + 0.5) + pageXOffset));
			scaleFactor = Math.min(scaleFactor,
				(clientY + screen * documentHeight / columns) / (windowHeight + pageYOffset));
			scaleFactor = Math.min(scaleFactor,
				(windowWidth + (screen + 1 - columns) * gutter - paddingSE - clientX) / (windowWidth * (columns - 1.5 - screen) + documentWidth - pageXOffset));
			scaleFactor = Math.min(scaleFactor,
				(windowHeight - clientY) / ((screen + 1) * documentHeight / columns - pageYOffset));
		} else if (rows > 1) {
			screen = Math.floor(rows * pageXOffset / documentWidth);
			scaleFactor = Math.min(scaleFactor,
				(clientY - screen * gutter - paddingNW) / (windowHeight * (screen + 0.5) + pageYOffset));
			scaleFactor = Math.min(scaleFactor,
				(clientX + screen * documentWidth / rows) / (windowWidth + pageXOffset));
			scaleFactor = Math.min(scaleFactor,
				(windowHeight + (screen + 1 - rows) * gutter - paddingSE - clientY) / (windowHeight * (rows - 1.5 - screen) + documentHeight - pageYOffset));
			scaleFactor = Math.min(scaleFactor,
				(windowWidth - clientX) / ((screen + 1) * documentWidth / rows - pageXOffset));
		}
		scaleFactor = Math.min(scaleFactor,
			settings.size / Math.min(documentWidth, documentHeight) / Math.pow(columns * rows, 1.1));
	} }
});
